import { Route, Switch } from "wouter";
import { Routes } from "./routes";
import * as R from "./routes";
import inDev from "../utils/inDebug";

const routesCrawler = (
	parentPath?: string,
	routesPack: Routes[] = R.routesRoot,
): JSX.Element[] => {
	// Roll through routes and generate Route for each
	return routesPack.map((route, index): JSX.Element => {
		// Debug log shows generated routes
		inDev(() =>
			console.log(
				"routesCrawler",
				parentPath ? parentPath + route.path : route.path,
			),
		);
		return (
			<>
				{/* Check does route have children and perform routing generation for children */}

				{route.children
					? routesCrawler(parentPath ?? "" + route.path, route.children)
					: null}
				<Route
					key={index}
					path={parentPath ? parentPath + route.path : route.path}
					component={route.component}
				/>
			</>
		);
	});
};

/**
 * This component is used to generate Switch with Routes for given routes object
 */
const SwitchRoutesGenerator = () => {
	return (
		<Switch>
			{routesCrawler()}
			<Route component={() => <>404</>} />
		</Switch>
	);
};

export default SwitchRoutesGenerator;
